RecentLog = {};
function RecentLog:new(o)
	o = o or {}
	self.log = {}
	self.count = 0
	self.numEntries = 60
	setmetatable(o, self)
	self.__index = self
	return o
end
function RecentLog:deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[self:deepcopy(orig_key)] = self:deepcopy(orig_value)
        end
        setmetatable(copy, self:deepcopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end
function RecentLog:getAllEvents()
	return self.log;
end
function RecentLog:getNumEntries()
	return self.numEntries
end
function RecentLog:getCount()
	return self.count
end

function RecentLog:add(entry)
	local newEntry = self:deepcopy(entry)
	local newLog = self:deepcopy(self.log);
	for i=0, self.numEntries-1 do
		if self.count > i then
			if i < self.numEntries then
				newLog[i+1] = self.log[i]
			end
		end
	end
	newLog[0] = newEntry
	if self.count < self.numEntries then
		self.count = self.count + 1
	end
	self.log = newLog
	--print(ChartMeAddon:dump(self.log))
end
function RecentLog:display()
	print(ChartMeAddon:dump(self.log))
end